TOOL_NAME = "Show Device`s Scripting Properties"

--global inst or device
local menu_type = nil

--Renoise Keybinds and menus
----------------------------
--Individual loaded device
--------------------------
renoise.tool():add_menu_entry {
  name = "DSP Device:"..TOOL_NAME,
  invoke = function()
             menu_type = "DEV"
             main_start()
           end  
}
--Instrument menu
-----------------
renoise.tool():add_menu_entry {
  name = "Instrument Box:"..TOOL_NAME,
  invoke = function()
             menu_type = "INST"
             main_start()
           end  
}
--FX Browser menus
------------------
renoise.tool():add_menu_entry {
  name = "DSP Chain List:Show All Available Device:Path",
  invoke = function()
             main_two("path")
           end  
}
renoise.tool():add_menu_entry {
  name = "DSP Chain List:Show All Available Device:Name",
  invoke = function()
             main_two("name")
           end  
}
renoise.tool():add_menu_entry {
  name = "DSP Chain List:Show All Available Device:Short Name",
  invoke = function()
             main_two("short name")
           end  
}
renoise.tool():add_menu_entry {
  name = "DSP Chain List:Show All Available Device:Favorite name",
  invoke = function()
             main_two("favorite name")
           end  
}
renoise.tool():add_menu_entry {
  name = "DSP Chain List:Show All Available Device:Is Favorite",
  invoke = function()
             main_two("is favorite")
           end  
}
renoise.tool():add_menu_entry {
  name = "DSP Chain List:Show All Available Device:Is Bridged",
  invoke = function()
             main_two("is bridged")
           end  
}



--global variables for gui
local my_dialog = nil 
local vb = nil

--[[
--toggle the tool open and closed (keyboard shortcut start-up)
-------------------------------------------------------------
function main_toggle()
----------------------
 --close dialog if it is open
  if (my_dialog and my_dialog.visible) then 
    my_dialog:close()
    --reset global my_dialog
     my_dialog = nil 
  else --run main
    main()
  end
end--]]

--always open/ restart tool (menu entry start-up)
-------------------------------------------------
function main_start()
---------------------
  if (my_dialog and my_dialog.visible) then 
    my_dialog:close()
    --reset global my_dialog
     my_dialog = nil 
  end
  --run main
  main()
end
----------------------------------------------------------


--------------------------------------------------------------------------------
--helper function : custom status message --prefixes tool name and adds brackets 
--------------------------------------------------------------------------------
local function status(message)
  renoise.app():show_status(TOOL_NAME.." Tool: ("..message..")")
end














------------------------------------
------------------------------------
function main(menu_call)
------------------------------------
------------------------------------


  --toggle dialog so if its already open then close it.  The timer will catch
  --that it is closed and do the housekeeping like removing notifiers (and timer itself)
  if (my_dialog and my_dialog.visible) then 
    my_dialog:close()
    return
  end
  
  
  --function returns a formatted string showing the devices properties
  --gets relevant depending on which menu is called ("INST" or "DEV" global flag)
  --------------------------------
  local function get_plugin_data()
  --------------------------------
   --song
    local song = renoise.song()
    --string returned at end of function with device info.
    local string = ""
    
    --when menu-called on instrument (menu_type = global flag)
    ----------------------------------
    if menu_type == "INST" then      
      --get selected instrument
      local inst = song.selected_instrument
      --check there is a plugin loaded and not a sampled instrument
      if inst.plugin_properties.plugin_device == nil then
        string = "No Plug Selected"
      else
        --if a plugin then get the relevant data
        local device = inst.plugin_properties.plugin_device
        string = string.."device_path:\n"..device.device_path.."\n\n"
        string = string.."name:\n"..device.name.."\n\n"
        string = string.."display_name:\n"..inst.name.."\n\n"
        --[[
        --***CRASHES/ HANGS RENOISE** bug has been reported 23/01/2019
        -- string = string.."active_preset_data:\n"..device.active_preset_data
        --Catch Crash
        
        print(#device.active_preset_data)
        if #device.active_preset_data <= 7997 then
          string = string.."active_preset_data:\n"..device.active_preset_data
        else
          string = string.."--- Cannot Display Preset Data, String Is Too Long! ---"
        end
        --string = string.char(string.byte(device.active_preset_data,1,7997)
        --]]
        
      end
      
    --when menu-called on a DSP device (menu_type = global flag)
    ----------------------------------
    elseif menu_type == "DEV" then
      --get selected device and data
      local device = song.selected_track_device
      string = string.."device_path:\n"..device.device_path.."\n\n"
      string = string.."name:\n"..device.name.."\n\n"
      string = string.."display_name:\n"..device.display_name.."\n\n" 
      string = string.."active_preset_data:\n"..device.active_preset_data
    end

    return string
  end
  ----

  --renoise song object
  local song = renoise.song()

  --set globals
  -------------
  --assign global vb to viewbuilder
  vb = renoise.ViewBuilder()
  

  ----------------------------------------------
  --GUI
  ----------------------------------------------     

  --variables that will be added to
  --dialog_content:add_child(send_row)
  local my_first_row = vb:row {}
  -------------------------------
  local my_first_element = nil
  
  --DUMMY CONTENT
  ----------------
  --loop to create buttons and add them to my_first_row
  for button = 1, 1 do
    --1 button
    my_first_element =vb:multiline_textfield { 
                         id = "readout string",
                         width = 310,
                         height = 200,
                         text = get_plugin_data()
                        }
                       

    --add each iteration into my_first_row
    my_first_row:add_child(my_first_element) 
  
  end --end loop
  
  --------------------------------------------------------
  --------------------------------------------------------
  --dialog content will contain all of gui; passed to renoise.app():show_custom_dialog()
  local dialog_content = vb:column{}
  dialog_content:add_child(my_first_row)


  
  --------------
  --key Handler
  --------------
  local function my_keyhandler_func(dialog,key)
     --toggle lock focus hack, allows pattern ed to get key input
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
     return key
  end 
  
 
  ------------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------------
  --Script dialog
  my_dialog = renoise.app():show_custom_dialog(
      TOOL_NAME, dialog_content,my_keyhandler_func)

 --[[ 
  --add timer to fire once every 50ms
  if not renoise.tool():has_timer(timer) then
    renoise.tool():add_timer(timer,80)
  end
  --]]
  
  --------------------------------------------    
  --close dialog function ON NEW SONG
  --------------------------------------------
  local function closer(d)
    --close dialog if exists and is open     
    if (d ~= nil) and (d.visible == true) then
      d:close()
     -- remove_notifiers()
    end
    --reset global my_dialog
     my_dialog = nil 
  end
  -- notifier to close dialog on load new song
  renoise.tool().app_release_document_observable:add_notifier(closer,my_dialog)
  -------------------------------------------------------------------------------
  
  --first run of timer
  -- timer()
end




------------------------------------
------------------------------------
function main_two(property_type)
------------------------------------
------------------------------------


  --toggle dialog so if its already open then close it.  The timer will catch
  --that it is closed and do the housekeeping like removing notifiers (and timer itself)
  if (my_dialog and my_dialog.visible) then 
    my_dialog:close()
  end
    
  --NOTES
  --------
  --available fx device infos in renoise 
  --------------------------------------
   -- renoise.song().tracks[].available_device_infos[]
  ---> [read-only, array of strings]
    
  -- Returns a list of tables containing more information about the devices. 
  -- Each table has the following fields:
  --  {
  --    path,           -- The device's path used by insert_device_at()
  --    name,           -- The device's name
  --    short_name,     -- The device's name as displayed in shortened lists
  --    favorite_name,  -- The device's name as displayed in favorites
  --    is_favorite,    -- true if the device is a favorite
  --    is_bridged      -- true if the device is a bridged plugin
  --  }
  
  --e.g.
  
  --  [favorite_name] =>  *Signal Follower
  --  [is_bridged] =>  false
  --  [is_favorite] =>  false
  --  [name] =>  Meta:*Signal Follower
  --  [path] =>  Audio/Effects/Native/*Signal Follower
  --  [short_name] =>  *Signal Follower
  
  
  -----------------------------------------------
  local function show_all_available_device_paths(property_type)
  -----------------------------------------------
  
    local song = renoise.song()
    local infos = song:track(1).available_device_infos
    local plugs_string = ""
    
  -- print(property_type)
    
    if property_type == "path" then
       plugs_string = property_type.."\n\n    renoise.song().track(1).available_device_infos[x].path\n\n"
      for i = 1,#infos do
        plugs_string = plugs_string..infos[i].path.."\n"
      end
    elseif property_type == "name" then
      plugs_string = property_type.."\n\n    renoise.song().track(1).available_device_infos[x].name\n\n"
      for i = 1,#infos do
        plugs_string = plugs_string..infos[i].name.."\n"
      end
    elseif property_type == "short name" then
      plugs_string = property_type.."\n\n    renoise.song().track(1).available_device_infos[x].short_name\n\n"
      for i = 1,#infos do
        plugs_string = plugs_string..infos[i].short_name.."\n"
      end
    elseif property_type == "favorite name" then
      plugs_string = property_type.."\n\n    renoise.song().track(1).available_device_infos[x].favorite_name\n\n"
      for i = 1,#infos do
        plugs_string = plugs_string..infos[i].favorite_name.."\n"
      end
    elseif property_type == "is favorite" then
      plugs_string = property_type.."\n\n    renoise.song().track(1).available_device_infos[x].is_favorite\n\n"
     -- plugs_string = plugs_string.."is_favorite    /   name\n\n"
      for i = 1,#infos do
        
        --This caused hang error with no 'tool hanging' exit window
        --name_string = plugs_string infos[i].short_name.."\n"
        
        --get is_favorite status
        local fav_string = nil
        if infos[i].is_favorite == true then
          fav_string = "true " --add space for formatting
        else
          fav_string = "false"
        end
        --plug name
        local name_string = infos[i].short_name
        --concatenate
        local all = fav_string.."  "..name_string.."\n" 
        --concatenate to output string
        plugs_string = plugs_string..all--.."\n"
      
      end
    elseif property_type == "is bridged" then
      plugs_string = property_type.."\n\n    renoise.song().track(1).available_device_infos[x].is_bridged\n\n"
     -- plugs_string = plugs_string.."is_bridged    /   name\n\n"
      for i = 1,#infos do
        
        --get is_bridged status
        local bridge_string = nil
        if infos[i].is_bridged == true then
          bridge_string = "true " --add space for formatting
        else
          bridge_string = "false"
        end
        --plug name
        local name_string = infos[i].short_name
        --concatenate
        local all = bridge_string.."  "..name_string.."\n" 
        --concatenate to output string
        plugs_string = plugs_string..all--.."\n"

      end
    end
      
    return plugs_string
  end
  
  
  
  

  --renoise song object
  local song = renoise.song()

  --set globals
  -------------
  --assign global vb to viewbuilder
  vb = renoise.ViewBuilder()
  

  ----------------------------------------------
  --GUI
  ----------------------------------------------     

  --variables that will be added to
  --dialog_content:add_child(send_row)
  local my_first_row = vb:row {}
  -------------------------------
  local my_first_element = nil
  
  --DUMMY CONTENT
  ----------------
  --loop to create buttons and add them to my_first_row
  for button = 1, 1 do
    --1 button
    my_first_element =vb:multiline_textfield { 
                         id = "readout string",
                         width = 400,
                         height = 600,
                         text = show_all_available_device_paths(property_type)
                        }
                       

    --add each iteration into my_first_row
    my_first_row:add_child(my_first_element) 
  
  end --end loop
  
  --------------------------------------------------------
  --------------------------------------------------------
  --dialog content will contain all of gui; passed to renoise.app():show_custom_dialog()
  local dialog_content = vb:column{}
  dialog_content:add_child(my_first_row)


  
  --------------
  --key Handler
  --------------
  local function my_keyhandler_func(dialog,key)
     --toggle lock focus hack, allows pattern ed to get key input
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
     return key
  end 
  
 
  ------------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------------
  --Script dialog
  my_dialog = renoise.app():show_custom_dialog(
      "Devices Info", dialog_content,my_keyhandler_func)

 --[[ 
  --add timer to fire once every 50ms
  if not renoise.tool():has_timer(timer) then
    renoise.tool():add_timer(timer,80)
  end
  --]]
  
  --------------------------------------------    
  --close dialog function ON NEW SONG
  --------------------------------------------
  local function closer(d)
    --close dialog if exists and is open     
    if (d ~= nil) and (d.visible == true) then
      d:close()
     -- remove_notifiers()
    end
    --reset global my_dialog
     my_dialog = nil 
  end
  -- notifier to close dialog on load new song
  renoise.tool().app_release_document_observable:add_notifier(closer,my_dialog)
  -------------------------------------------------------------------------------
  
  --first run of timer
  -- timer()
end






